<?php

namespace App\Controller;

use App\Entity\Problem;
use App\Entity\Solution;
use App\Form\ProblemType;
use App\Form\SolutionType;
use App\Repository\VoteRepository;
use App\Repository\ProblemRepository;
use App\Service\FileUploader;
use Doctrine\ORM\EntityManagerInterface;
use App\Repository\SolutionRepository;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Security\Core\Security;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;

/**
 * @Route("/problem")
 */
class ProblemController extends AbstractController
{


public function __construct(Security $security)
{
    
    $this->security = $security;
}

    /**
     * @Route("/", name="problem_index", methods={"GET"})
     */
    public function index(ProblemRepository $problemRepository): Response
    {
        return $this->render('problem/index.html.twig', [
            'problems' => $problemRepository->findAll(),
        ]);
    }

    /**
     * @Route("/create", name="problem_new", methods={"GET","POST"})
     */
    public function new(Request $request, EntityManagerInterface $em, FileUploader $fileUploader): Response
    {
        $user = $this->security->getUser();
        $problem = new Problem();
        $form = $this->createForm(ProblemType::class, $problem);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {

            $problem = $form->getData();
            $file = $form['image']->getData();

            if($file){
                $fileName = $fileUploader->upload($file);
                $problem->setImage($fileName);
            }else{
                
            }
            
            $problem->setUser($user);
            $em->persist($problem);
            $em->flush();

            return $this->redirectToRoute('problem_index');
        }

        return $this->render('problem/new.html.twig', [
            'problem' => $problem,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/show/{id}", name="problem_show", methods={"GET"})
     */
    public function show(Problem $problem, VoteRepository $voteRepo, int $id, SolutionRepository $solutionRepo): Response
    {
        $user = $this->security->getUser();
        $solutions = $solutionRepo->findBy(['problem' => $id]);
        $data=[];

        if (!$solutions) {$vote = null;}

        foreach ($solutions as &$solution) {
            $vote = $voteRepo->findOneBy(['user'=>$user, 'solution'=>$solution]);
            $voteFor = count($voteRepo->findBy(['solution'=>$solution,'resulteVote'=>true]));
            $voteAgainst = count($voteRepo->findBy(['solution'=>$solution,'resulteVote'=>false]));
            $voteArray= array($voteFor,$voteAgainst);
            array_push($data,$voteArray);
        }
        
        return $this->render('problem/show.html.twig', [
            'problem' => $problem,
            'vote'=>$vote,
            'data'=>$data,
        ]);
    }



    /**
     * @Route("/{id}/edit", name="problem_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, Problem $problem): Response
    {
        $form = $this->createForm(ProblemType::class, $problem);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('problem_index');
        }

        return $this->render('problem/edit.html.twig', [
            'problem' => $problem,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="problem_delete", methods={"DELETE"})
     */
    public function delete(Request $request, Problem $problem): Response
    {
        if ($this->isCsrfTokenValid('delete'.$problem->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($problem);
            $entityManager->flush();
        }

        return $this->redirectToRoute('problem_index');
    }

    /**
     * @return string
     */
    private function generateUniqueFileName()
    {
        // md5() reduces the similarity of the file names generated by
        // uniqid(), which is based on timestamps
        return md5(uniqid());
    }
}
